Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Jobs/OptimizerJob.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Jobs/OptimizerJob.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Jobs/OptimizerJob.cs	(revision 4423)
@@ -1,3 +1,4 @@
 ﻿using System;
+using System.Linq;
 using System.Collections.Generic;
 using HeuristicLab.Core;
@@ -5,14 +6,10 @@
 using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
 
 namespace HeuristicLab.Hive.Experiment.Jobs {
   [StorableClass]
   public class OptimizerJob : IJob {
-    [Storable]
-    protected Guid internalId;
-    public Guid InternalId {
-      get { return internalId; }
-    }
-    
     [Storable]
     protected IOptimizer optimizer;
@@ -20,16 +17,16 @@
       get { return optimizer; }
       set {
-        if (optimizer != null && value != optimizer) {
-          DeregisterEvents();
-        }
-        optimizer = value;
-        if (optimizer != null) {
-          RegisterEvents();
+        if (value != optimizer) {
+          if (optimizer != null) {
+            DeregisterEvents();
+          }
+          optimizer = value;
+          if (optimizer != null) {
+            RegisterEvents();
+          }
+          OnOptimizerChanged();
         }
       }
     }
-
-    [Storable]
-    protected double progress = 0.0;
 
     [Storable]
@@ -40,37 +37,32 @@
 
     [Storable]
-    protected ICollection<IJob> childJobs;
-    public IEnumerable<IJob> ChildJobs {
-      get { return childJobs; }
-    }
-
-    [Storable]
     protected bool computeInParallel;
     public bool ComputeInParallel {
       get { return computeInParallel; }
-      set { computeInParallel = value; }
-    }
-
-    [Storable]
-    protected int coresNeeded;
-    public int CoresNeeded {
-      get { return coresNeeded; }
-      set { coresNeeded = value; }
-    }
-
-    [Storable]
-    protected int memoryNeeded;
-    public int MemoryNeeded {
-      get { return memoryNeeded; }
-      set { memoryNeeded = value; }
+      set {
+        if (computeInParallel != value) {
+          computeInParallel = value;
+          OnComputeInParallelChanged();
+        }
+      }
+    }
+
+    [Storable]
+    private int indexInParentOptimizerList = -1;
+    public int IndexInParentOptimizerList {
+      get { return indexInParentOptimizerList; }
+      set { this.indexInParentOptimizerList = value; }
+    }
+
+
+    [Storable]
+    private bool collectChildJobs;
+    public bool CollectChildJobs {
+      get { return collectChildJobs; }
+      set { collectChildJobs = value; }
     }
 
     public OptimizerJob() {
-      this.internalId = Guid.NewGuid();
       this.log = new Log();
-      this.childJobs = new List<IJob>();
-      this.ComputeInParallel = false;
-      this.CoresNeeded = 1;
-      this.MemoryNeeded = 0;
     }
 
@@ -78,4 +70,12 @@
       : this() {
       this.optimizer = optimizer;
+
+      if (optimizer is Optimization.Experiment) {
+        this.ComputeInParallel = true;
+      } else if (optimizer is Optimization.BatchRun) {
+        this.ComputeInParallel = false;
+      } else {
+        this.ComputeInParallel = false;
+      }
     }
 
@@ -85,9 +85,19 @@
     }
 
+    /// <summary>
+    /// Casts the Optimizer to an Experiment. Returns null if cast was not successfull.
+    /// </summary>
+    public Optimization.Experiment OptimizerAsExperiment {
+      get { return Optimizer as Optimization.Experiment; }
+    }
+
+    /// <summary>
+    /// Casts the Optimizer to an BatchRun. Returns null if cast was not successfull.
+    /// </summary>
+    public Optimization.BatchRun OptimizerAsBatchRun {
+      get { return Optimizer as Optimization.BatchRun; }
+    }
+
     #region IJob Members
-    
-    public double Progress {
-      get { return optimizer.ExecutionState == ExecutionState.Stopped ? 1.0 : this.progress; }
-    }
 
     public virtual ExecutionState ExecutionState {
@@ -95,4 +105,8 @@
     }
 
+    public TimeSpan ExecutionTime {
+      get { return optimizer.ExecutionTime; }
+    }
+
     public virtual void Run() {
       throw new NotSupportedException();
@@ -104,5 +118,10 @@
 
     public virtual void Start() {
-      optimizer.Start();
+      if ((optimizer is Optimization.Experiment && OptimizerAsExperiment.Optimizers.Count == 0) || // experiment would not fire OnStopped if it has 0 optimizers
+          (optimizer is Optimization.BatchRun && OptimizerAsBatchRun.Algorithm == null)) { // batchrun would not fire OnStopped if algorithm == null
+        OnJobStopped();
+      } else {
+        optimizer.Start();
+      }
     }
 
@@ -112,5 +131,5 @@
 
     public virtual void Resume(IEnumerable<IJob> childJobs) {
-      throw new NotSupportedException();
+      OnJobStopped();
     }
 
@@ -122,13 +141,13 @@
 
     public event EventHandler JobFailed;
-    protected virtual void OnJobFailed(Common.EventArgs<Exception> e) {
+    protected virtual void OnJobFailed(EventArgs<Exception> e) {
       EventHandler handler = JobFailed;
       if (handler != null) handler(this, e);
     }
 
-    public event EventHandler<Common.EventArgs<IJob>> NewChildJob;
+    public event EventHandler<EventArgs<IJob>> NewChildJob;
     protected virtual void OnNewChildJob(IJob job) {
       EventHandler<Common.EventArgs<IJob>> handler = NewChildJob;
-      if (handler != null) handler(this, new Common.EventArgs<IJob>(job));
+      if (handler != null) handler(this, new EventArgs<IJob>(job));
     }
 
@@ -139,4 +158,21 @@
     }
 
+    public event EventHandler DeleteChildJobs;
+    protected virtual void OnDeleteChildJobs() {
+      EventHandler handler = DeleteChildJobs;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler ComputeInParallelChanged;
+    protected virtual void OnComputeInParallelChanged() {
+      EventHandler handler = ComputeInParallelChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler OptimizerChanged;
+    protected virtual void OnOptimizerChanged() {
+      EventHandler handler = OptimizerChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
     #endregion
 
@@ -165,12 +201,8 @@
 
     protected virtual void optimizer_ExceptionOccurred(object sender, Common.EventArgs<Exception> e) {
-      if (optimizer.ExecutionState != ExecutionState.Stopped) this.progress = 0.0;
-      else this.progress = 1.0;
       OnJobFailed(e);
     }
 
     protected virtual void optimizer_Stopped(object sender, EventArgs e) {
-      if (optimizer.ExecutionState != ExecutionState.Stopped) this.progress = 0.0;
-      else this.progress = 1.0;
       OnJobStopped();
     }
@@ -237,6 +269,14 @@
     #region IDeepCloneable Members
 
-    public Common.IDeepCloneable Clone(Common.Cloner cloner) {
-      throw new NotImplementedException();
+    public Common.IDeepCloneable Clone(Cloner cloner) {
+      OptimizerJob clone = (OptimizerJob)Activator.CreateInstance(this.GetType());
+      cloner.RegisterClonedObject(this, clone);
+      clone.Optimizer = (IOptimizer)cloner.Clone(this.Optimizer);
+      clone.log = (ILog)cloner.Clone(this.Log);
+      clone.ComputeInParallel = this.ComputeInParallel;
+      clone.IndexInParentOptimizerList = this.IndexInParentOptimizerList;
+      clone.CollectChildJobs = this.CollectChildJobs;
+      clone.RegisterEvents();
+      return clone;
     }
 
@@ -246,5 +286,5 @@
 
     public object Clone() {
-      throw new NotImplementedException();
+      return Clone(new Cloner());
     }
 
@@ -258,8 +298,9 @@
       return Name;
     }
-    
+
     public virtual bool IsParallelizable {
-      get { return false; }
-    }
+      get { return this.Optimizer is Optimization.Experiment || this.Optimizer is BatchRun; }
+    }
+
   }
 }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Progress/IProgress.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Progress/IProgress.cs	(revision 4423)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Progress/IProgress.cs	(revision 4423)
@@ -0,0 +1,17 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Hive.Experiment {
+  public interface IProgress {
+    string Status { get; set; }
+    double ProgressValue { get; set; }
+
+    void Finish();
+
+    event EventHandler Finished;
+    event EventHandler StatusChanged;
+    event EventHandler ProgressValueChanged;
+  }
+}
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Progress/IProgressReporter.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Progress/IProgressReporter.cs	(revision 4423)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Progress/IProgressReporter.cs	(revision 4423)
@@ -0,0 +1,14 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Hive.Experiment {
+  public interface IProgressReporter {
+    IProgress Progress { get; }
+    bool IsProgressing { get; }
+
+    event EventHandler IsProgressingChanged;
+  }
+}
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Progress/Progress.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Progress/Progress.cs	(revision 4423)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Progress/Progress.cs	(revision 4423)
@@ -0,0 +1,64 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Hive.Experiment {
+  public class Progress : IProgress {
+    private string status;
+    public string Status {
+      get {
+        return this.status;
+      }
+      set {
+        if (this.status != value) {
+          this.status = value;
+          OnStatusChanged();
+        }
+      }
+    }
+
+    private double progressValue;
+    public double ProgressValue {
+      get {
+        return this.progressValue;
+      }
+      set {
+        if (this.progressValue != value) {
+          this.progressValue = value;
+          OnProgressChanged();
+        }
+      }
+    }
+
+    public Progress() { }
+
+    public Progress(string status) {
+      this.Status = status;
+    }
+
+    public void Finish() {
+      OnFinished();
+    }
+
+    #region Event Handler
+    public event EventHandler Finished;
+    private void OnFinished() {
+      var handler = Finished;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler StatusChanged;
+    private void OnStatusChanged() {
+      var handler = StatusChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler ProgressValueChanged;
+    private void OnProgressChanged() {
+      var handler = ProgressValueChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    #endregion
+  }
+}
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/ServiceLocator.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/ServiceLocator.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/ServiceLocator.cs	(revision 4423)
@@ -46,4 +46,21 @@
     }
 
+    public ServiceLocator() {
+      Settings.Default.SettingChanging += new System.Configuration.SettingChangingEventHandler(Default_SettingChanging);
+    }
+
+    void Default_SettingChanging(object sender, System.Configuration.SettingChangingEventArgs e) {
+      if (clientFacadePool != null) {
+        clientFacadePool.HostAddress = Settings.Default.HiveServerIp;
+        clientFacadePool.Username = Settings.Default.HiveUsername;
+        clientFacadePool.Password = Settings.Default.HivePassword;
+      }
+      if (streamedClientFacadePool != null) {
+        streamedClientFacadePool.HostAddress = Settings.Default.HiveServerIp;
+        streamedClientFacadePool.Username = Settings.Default.HiveUsername;
+        streamedClientFacadePool.Password = Settings.Default.HivePassword;
+      }
+    }
+
     internal WcfServicePool<IClientFacade> ClientFacadePool {
       get {
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/Interfaces/IJob.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/Interfaces/IJob.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/Interfaces/IJob.cs	(revision 4423)
@@ -3,17 +3,12 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using System.Collections.Generic;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Hive.JobBase {
   public interface IJob : INamedItem {
-    /// <summary>
-    /// This ID is needed to identify the object when it returns from hive
-    /// </summary>
-    Guid InternalId { get; }
+    TimeSpan ExecutionTime { get; }
 
     ExecutionState ExecutionState { get; }
-    IEnumerable<IJob> ChildJobs { get; }
-    double Progress { get; }
-    ILog Log { get; }
-
+    
     /// <summary>
     /// indicates wether it is possible to create childjobs from this job
@@ -26,15 +21,6 @@
     /// </summary>
     bool ComputeInParallel { get; set; }
+    event EventHandler ComputeInParallelChanged;
 
-    /// <summary>
-    /// Gets or sets the cores that will be needed by this job
-    /// </summary>
-    int CoresNeeded { get; set; }
-
-    /// <summary>
-    /// Gets or sets the memory that will be consumed by this job
-    /// </summary>
-    int MemoryNeeded { get; set; }
-    
     void Run();
     void Prepare();
@@ -52,7 +38,17 @@
 
     /// <summary>
-    /// This event will be thrown when the job wants to have a child-job to be computed
+    /// This event will be fired when the job wants to have a child-job to be computed
     /// </summary>
-    event EventHandler<Common.EventArgs<IJob>> NewChildJob;
+    event EventHandler<EventArgs<IJob>> NewChildJob;
+
+    /// <summary>
+    /// Will be fired when job wants all child-jobs to be deleted from hive
+    /// </summary>
+    event EventHandler DeleteChildJobs;
+    
+    /// <summary>
+    /// If this is set to true, the job should be Resumed with the child-jobs attatched instead of Started
+    /// </summary>
+    bool CollectChildJobs { get; set; }
   }
 }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Console/3.3/HiveServerManagementConsole.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Console/3.3/HiveServerManagementConsole.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Console/3.3/HiveServerManagementConsole.cs	(revision 4423)
@@ -345,5 +345,11 @@
       foreach (ResourceDto resource in clientGroup.Resources) {
         if (resource is SlaveDto) {
-          int percentageUsage = CapacityRam(((SlaveDto)resource).NrOfCores, ((SlaveDto)resource).NrOfFreeCores);
+          int percentageUsage;
+          if (((SlaveDto)resource).NrOfCores.HasValue && ((SlaveDto)resource).NrOfFreeCores.HasValue) {
+            percentageUsage = CapacityRam(((SlaveDto)resource).NrOfCores.Value, ((SlaveDto)resource).NrOfFreeCores.Value);
+          } else {
+            percentageUsage = 0;
+          }
+
           int usage = 3;
           if ((((SlaveDto)resource).State != SlaveState.Offline) &&
@@ -427,8 +433,7 @@
 
       lblJobName.Text = job.Id.ToString();
-      if (job.Percentage != null) {
-        progressJob.Value = (int)(currentJob.Percentage * 100);
-        lblProgress.Text = (int)(currentJob.Percentage * 100) + "% calculated";
-      }
+
+      progressJob.Value = (int)(currentJob.ExecutionTime.TotalDays % 1) * progressJob.Maximum;
+      lblProgress.Text = currentJob.ExecutionTime.ToString();
 
       ListViewItem lvi = new ListViewItem();
@@ -443,9 +448,9 @@
       lvJobDetails.Items.Add(lvi);
 
-      if (job.ParentJob != null) {
+      if (job.ParentJobId != null) {
         lvi = null;
         lvi = new ListViewItem();
         lvi.Text = "Parent job:";
-        lvi.SubItems.Add(job.ParentJob.ToString());
+        lvi.SubItems.Add(job.ParentJobId.ToString());
         lvJobDetails.Items.Add(lvi);
       }
@@ -497,5 +502,10 @@
 
       if (currentSlave != null) {
-        int percentageUsage = CapacityRam(currentSlave.NrOfCores, currentSlave.NrOfFreeCores);
+        int percentageUsage;
+        if (currentSlave.NrOfCores.HasValue && currentSlave.NrOfFreeCores.HasValue) {
+          percentageUsage = CapacityRam(currentSlave.NrOfCores.Value, currentSlave.NrOfFreeCores.Value);
+        } else {
+          percentageUsage = 0;
+        }
         int usage = 3;
         if ((currentSlave.State != SlaveState.Offline) && (currentSlave.State != SlaveState.NullState)) {
@@ -807,5 +817,5 @@
             if (job.State != JobState.Offline) {
               if ((!IsEqual(job.Slave, jobold.Slave)) || (job.State != jobold.State)
-                   || (job.Percentage != jobold.Percentage)) {
+                   || (job.ExecutionTime != jobold.ExecutionTime)) {
                 change = true;
               }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Authorization/AuthorizationManager.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Authorization/AuthorizationManager.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Authorization/AuthorizationManager.cs	(revision 4423)
@@ -21,5 +21,5 @@
     }
 
-    public void AuthorizeForJobs(params Guid[] jobIds) {
+    public void AuthorizeJobs(params Guid[] jobIds) {
       if (!IsAuthorizedForJobs(jobIds)) {
         throw new SecurityException("User '" + Identity.UserName + "' is not authorized to access job (Id: " + string.Join(", ", jobIds.Select(x => x.ToString()).ToArray()) + ")");
@@ -30,4 +30,10 @@
       return DaoLocator.JobDao.IsUserAuthorizedForJobs(UserId, jobIds);
     }
+
+    public void Authorize(Guid userId) {
+      if (userId != this.UserId) {
+        throw new SecurityException("User '" + Identity.UserName + "' is not authorized to access object");
+      }
+    }
   }
 }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/DaoLocator.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/DaoLocator.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/DaoLocator.cs	(revision 4423)
@@ -14,4 +14,5 @@
     [ThreadStatic] private static IPluginInfoDao pluginInfoDao;
     [ThreadStatic] private static IUptimeCalendarDao uptimeCalendarDao;
+    [ThreadStatic] private static IHiveExperimentDao hiveExperimentDao;
 
     public static ISlaveDao SlaveDao {
@@ -62,4 +63,12 @@
       }
     }
+
+    public static IHiveExperimentDao HiveExperimentDao {
+      get {
+        if (hiveExperimentDao == null)
+          hiveExperimentDao = new HiveExperimentDao();
+        return hiveExperimentDao;
+      }
+    }
   }
 }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/DefaultScheduler.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/DefaultScheduler.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/DefaultScheduler.cs	(revision 4423)
@@ -40,8 +40,10 @@
             }
 
-            LinkedList<JobDto> offlineJobsForSlave = new LinkedList<JobDto>(DaoLocator.JobDao.FindFittingJobs(JobState.Offline, slave.NrOfFreeCores, slave.FreeMemory, slave.Id));
-            if (offlineJobsForSlave != null && offlineJobsForSlave.Count > 0) {
-              jobToCalculate = offlineJobsForSlave.First.Value;
-              UpdateJobAsCalculating(jobToCalculate, slave);
+            if (slave.NrOfFreeCores.HasValue && slave.FreeMemory.HasValue) {
+              LinkedList<JobDto> offlineJobsForSlave = new LinkedList<JobDto>(DaoLocator.JobDao.FindFittingJobs(JobState.Offline, slave.NrOfFreeCores.Value, slave.FreeMemory.Value, slave.Id));
+              if (offlineJobsForSlave != null && offlineJobsForSlave.Count > 0) {
+                jobToCalculate = offlineJobsForSlave.First.Value;
+                UpdateJobAsCalculating(jobToCalculate, slave);
+              }
             }
           }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ClientFacade.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ClientFacade.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ClientFacade.cs	(revision 4423)
@@ -62,5 +62,5 @@
     public Response RequestSnapshot(Guid jobId) {
       using (contextFactory.GetContext()) {
-        ServiceLocator.GetAuthorizationManager().AuthorizeForJobs(jobId);
+        ServiceLocator.GetAuthorizationManager().AuthorizeJobs(jobId);
         return jobManager.RequestSnapshot(jobId);
       }
@@ -71,5 +71,5 @@
     public ResponseObject<SerializedJob> GetLastSerializedResult(Guid jobId) {
       using (contextFactory.GetContext(false)) {
-        ServiceLocator.GetAuthorizationManager().AuthorizeForJobs(jobId);
+        ServiceLocator.GetAuthorizationManager().AuthorizeJobs(jobId);
         return jobManager.GetLastSerializedResult(jobId);
       }
@@ -80,5 +80,5 @@
     public ResponseObject<SerializedJob> GetSnapshotResult(Guid jobId) {
       using (contextFactory.GetContext(false)) {
-        ServiceLocator.GetAuthorizationManager().AuthorizeForJobs(jobId);
+        ServiceLocator.GetAuthorizationManager().AuthorizeJobs(jobId);
         return jobManager.GetSnapshotResult(jobId);
       }
@@ -89,5 +89,5 @@
     public ResponseObject<JobDto> GetJobById(Guid jobId) {
       using (contextFactory.GetContext(false)) {
-        ServiceLocator.GetAuthorizationManager().AuthorizeForJobs(jobId);
+        ServiceLocator.GetAuthorizationManager().AuthorizeJobs(jobId);
         return jobManager.GetJobById(jobId);
       }
@@ -98,5 +98,5 @@
     public Response AbortJob(Guid jobId) {
       using (contextFactory.GetContext()) {
-        ServiceLocator.GetAuthorizationManager().AuthorizeForJobs(jobId);
+        ServiceLocator.GetAuthorizationManager().AuthorizeJobs(jobId);
         return jobManager.AbortJob(jobId);
       }
@@ -107,5 +107,5 @@
     public ResponseObject<JobResultList> GetJobResults(IEnumerable<Guid> jobIds) {
       using (contextFactory.GetContext(false)) {
-        ServiceLocator.GetAuthorizationManager().AuthorizeForJobs(jobIds.ToArray());
+        ServiceLocator.GetAuthorizationManager().AuthorizeJobs(jobIds.ToArray());
         return jobManager.GetJobResults(jobIds);
       }
@@ -117,5 +117,5 @@
       using (contextFactory.GetContext(false)) {
         if (parentJobId.HasValue) {
-          ServiceLocator.GetAuthorizationManager().AuthorizeForJobs(parentJobId.Value);
+          ServiceLocator.GetAuthorizationManager().AuthorizeJobs(parentJobId.Value);
         } 
         // If parentJobId is null, GetChildJobResults will filter the results for the current user
@@ -123,7 +123,47 @@
       }
     }
+
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Client)]
+    public ResponseObject<HiveExperimentDtoList> GetHiveExperiments() {
+      using (contextFactory.GetContext(false)) {
+        return jobManager.GetHiveExperiments();
+      }
+    }
+
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Client)]
+    public ResponseObject<HiveExperimentDto> UpdateHiveExperiment(HiveExperimentDto hiveExperimentDto) {
+      using (contextFactory.GetContext()) {
+        if (hiveExperimentDto.UserId == Guid.Empty) {
+          hiveExperimentDto.UserId = ServiceLocator.GetAuthorizationManager().UserId;
+        } else {
+          ServiceLocator.GetAuthorizationManager().Authorize(hiveExperimentDto.UserId);
+        }
+        return jobManager.UpdateHiveExperiment(hiveExperimentDto);
+      }
+    }
+
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Client)]
+    public Response DeleteHiveExperiment(Guid hiveExperimentId) {
+      using (contextFactory.GetContext()) {
+        var hiveExperimentDto = DaoLocator.HiveExperimentDao.FindById(hiveExperimentId);
+        if (hiveExperimentDto != null) {
+          ServiceLocator.GetAuthorizationManager().Authorize(hiveExperimentDto.UserId);
+        }
+        return jobManager.DeleteHiveExperiment(hiveExperimentId);
+      }
+    }
+
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Client)]
+    public ResponseObject<JobDto> AddChildJob(Guid parentJobId, SerializedJob serializedJob) {
+      using (contextFactory.GetContext()) {
+        ServiceLocator.GetAuthorizationManager().AuthorizeJobs(parentJobId);
+        return jobManager.AddChildJob(parentJobId, serializedJob);
+      }
+    }
     #endregion
-
-
   }
 }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ServerConsoleFacade.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ServerConsoleFacade.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ServerConsoleFacade.cs	(revision 4423)
@@ -237,5 +237,5 @@
     [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
     public ResponseObject<JobResultList> GetChildJobResults(Guid? parentJobId, bool recursive, bool includeParent) {
-      using (contextFactory.GetContext()) {
+      using (contextFactory.GetContext(false)) {
         return jobManager.GetChildJobResults(parentJobId, recursive, includeParent);
       }
@@ -255,4 +255,33 @@
       }
     }
+
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
+    public ResponseObject<HiveExperimentDtoList> GetHiveExperiments() {
+      using (contextFactory.GetContext(false)) {
+        return jobManager.GetHiveExperiments();
+      }
+    }
+
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
+    public ResponseObject<HiveExperimentDto> UpdateHiveExperiment(HiveExperimentDto hiveExperimentDto) {
+      using (contextFactory.GetContext()) {
+        return jobManager.UpdateHiveExperiment(hiveExperimentDto);
+      }
+    }
+
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
+    public Response DeleteHiveExperiment(Guid hiveExperimentId) {
+      using (contextFactory.GetContext()) {
+        return jobManager.DeleteHiveExperiment(hiveExperimentId);
+      }
+    }
+
+    [PrincipalPermission(SecurityAction.Demand, Role = HiveRoles.Administrator)]
+    public Response DeleteChildJobs(Guid jobId) {
+      using (contextFactory.GetContext()) {
+        return jobManager.DeleteChildJobs(jobId);
+      }
+    }
+
   }
 }
